﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=5.2
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public manager As BleManager2
	Public currentStateText As String = "UNKNOWN"
	Public currentState As Int
	Public connected As Boolean = False
	Public ConnectedName As String
	Private ConnectedServices As List
	Public rp As RuntimePermissions
	Public bc As ByteConverter
	Public SharedFolder As String
	Public Macaddress_BLE As String
	Dim Service_BLE As String ="3e135142-654f-9090-134a-a6ff5bb77046"
	Private Send_Command_BLE As String ="3fa4585a-ce4a-3bad-db4b-b8df8179ea09"
	Private Notify_BLE As String="d0e8434d-cd29-0996-af41-6c90f4e0eb2a"
	Private Event_Type As Int
	Private Event_Search_BLE As Int=0
	Private Event_Connect_BLE As Int =1
	Private Event_Read_Temp_BLE As Int=2
	Private Event_Read_Mode_BLE As Int=3
	Private Event_Read_Boost_BLE As Int=4
	Private Event_Read_Statut_Key_BLE As Int=5
	Private Event_Read_Statut_Vanne As Int=6
	
	Private ServiceBeewi As String="a8b3ff00-4834-4051-89d0-3de95cddd318"
	Private BeewiSetPowerOnOff As String="a8b3ff04-4834-4051-89d0-3de95cddd318"
	
	'Public scan_device As List
End Sub

Sub Service_Create
	manager.Initialize("manager")
	
	SharedFolder = rp.GetSafeDirDefaultExternal("shared")
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Public Sub ReadData
	For Each s As String In ConnectedServices
		manager.ReadData(s)
	Next
End Sub

Public Sub Disconnect
	manager.Disconnect
	Manager_Disconnected
End Sub

Sub Manager_StateChanged (State As Int)
	Select State
		Case manager.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"
		Case manager.STATE_POWERED_ON
			currentStateText = "POWERED ON"
		Case manager.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
	currentState = State
	CallSub(Setup, "StateChanged")
End Sub

Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	
	Dim Id_sensor_found As Boolean=False
	
	If Setup_Power_connected.Reconnect_BLE=False Then
		Macaddress_BLE=""
	End If
	
	Event_Type=Event_Search_BLE
		
	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI & ", " & AdvertisingData) 'ignore
	
	If Main.new_location=False  Then
		
		If Main.list_Read_Setup.Size<>0 Then
			Try
				For Each MACadress As String In Main.list_Read_Setup 'Enumere la liste des Macadress déjà enregistrées et les exclues de la recherche
					Dim Enum_Macadress() As String= Regex.Split(";",MACadress)
		
					If Name="MJ_HT_V1" Then 'filtre sur le model de sensor
					
						If Enum_Macadress(2)=Id Then
							Id_sensor_found=True
						End If
					End If
				Next
			Catch
				ToastMessageShow("Impossible de lire le fichier de configuration",True)
			End Try
			
			
			If Id_sensor_found=False And Name="MJ_HT_V1" Then
				CallSub3(Setup,"add_list_service",Name,Id & ";" & RSSI)
			Else If Setup_Power_connected.Scan_Power_BLE=True And Name="CC-RT-BLE" Then 'Filtre sur le model de la commande
				
				If Macaddress_BLE=Id Then
					CallSub3(Setup_Power_connected,"BLE_return",Event_Type,"ok")
					StopScan
					manager.Connect2(Id,False)
				Else
					Macaddress_BLE=Id
					CallSub3(Setup_Power_connected,"BLE_return",Event_Type,"ok")
					StopScan
					manager.Connect2(Id,False)
				End If
				
			End If
		
		Else
			
			If Name="MJ_HT_V1" Then 'filtre sur le model de sensor
				CallSub3(Setup,"add_list_service",Name,Id & ";" & RSSI)
			Else If Setup_Power_connected.Scan_Power_BLE=True And Name="CC-RT-BLE" Then 'Filtre sur le model de la commande
				If Macaddress_BLE=Id Then
					CallSub3(Setup_Power_connected,"BLE_return",Event_Type,"ok")
					StopScan
					manager.Connect2(Id,False)
				Else
					Macaddress_BLE=Id
					CallSub3(Setup_Power_connected,"BLE_return",Event_Type,"ok")
					StopScan
					manager.Connect2(Id,False)
				End If
			
			End If
			
		End If
			
	Else
		If Name="MJ_HT_V1" Then 'filtre sur le model de sensor
						
			CallSub3(Setup,"add_list_service",Name,Id & ";" & RSSI)
			
		Else If Setup_Power_connected.Scan_Power_BLE=True And Name="CC-RT-BLE" Then 'Filtre sur le model de la commande
			If Macaddress_BLE=Id Then
				CallSub3(Setup_Power_connected,"BLE_return",Event_Type,"ok")
				StopScan
				manager.Connect2(Id,False)
			Else
				Macaddress_BLE=Id
				CallSub3(Setup_Power_connected,"BLE_return",Event_Type,"ok")
				StopScan
				manager.Connect2(Id,False)
			End If
		End If
	End If
	
	
End Sub

public Sub StopScan
	Setup_Power_connected.Reconnect_BLE=False
	manager.StopScan
End Sub

Public Sub Connect_BLE
	manager.Connect2(Macaddress_BLE,False)
End Sub

Public Sub StartScan
	If manager.State <> manager.STATE_POWERED_ON Then
		Log("Not powered on.")
	Else If rp.Check(rp.PERMISSION_ACCESS_COARSE_LOCATION) = False Then
		Log("No location permission.")
	Else
		manager.Scan2(Null, False)
	End If
End Sub

'Sub Manager_DataAvailable (ServiceId As String, Characteristics As Map)
'	CallSub3(Main, "DataAvailable", ServiceId, Characteristics)
'End Sub

Sub Manager_Disconnected
	Log("Disconnected")
	connected = False
	CallSub(Main, "StateChanged")
	If Setup_Power_connected.Scan_Power_BLE=True Then
		CallSub3(Setup_Power_connected,"BLE_return",Event_Connect_BLE,"ko")
	End If
End Sub

Sub Manager_Connected (services As List)
	
	Log("Connected")
	connected = True
	ConnectedServices = services
	CallSub(Main, "StateChanged")
	
	If Setup_Power_connected.Scan_Power_BLE=True Then
		CallSub3(Setup_Power_connected,"BLE_return",Event_Connect_BLE,"ok")
	End If
	
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Command_BLE(Command As String, Write As Boolean)
	
	Dim year As Int= DateTime.GetYear(DateTime.Now) Mod 100
	
	Dim Time_synchro() As Byte = Array As Byte(03,year,DateTime.GetMonth(DateTime.Now),DateTime.GetDayOfMonth(DateTime.Now), _
	DateTime.GetHour(DateTime.Now),DateTime.GetMinute(DateTime.Now),DateTime.GetSecond(DateTime.Now))
	'Dim Time_synchro() As Byte = Array As Byte(65,36)
	If Setup_Power_connected.Type_power=Setup_Power_connected.Thermo Then
		If Write=False Then
			
		Else
			If Command="Synchro_Time" Then
				manager.WriteData(Service_BLE,Send_Command_BLE,Time_synchro)
							
			End If
		End If
	End If
	manager.SetNotify(Service_BLE,Notify_BLE,True)
	
End Sub

Sub Manager_DataAvailable (ServiceId As String, Characteristics As Map)
	Try
		For Each id As String In Characteristics.Keys
			Dim value() As Byte=Characteristics.Get(id)
			
			If value(0)=2 And value(1)=1 Then 'Notification Etat after synchonisation
								
				Dim value2(1) As Byte
				value2(0)=value(2)
				
				Dim hexa_code As String= bc.HexFromBytes(value2)
				
				Select Case hexa_code.SubString2(0,1) 'Indication Key locked
					
					Case "0"
						Log("Key Unlocked")
						CallSub3(Setup_Power_connected,"BLE_return",Event_Read_Statut_Key_BLE,"Déverrouillé")
					Case Else
						Log("Key Locked")
						CallSub3(Setup_Power_connected,"BLE_return",Event_Read_Statut_Key_BLE,"Verrouillé")
					
				End Select
				
							
				Select Case hexa_code.SubString2(1,2) 'Indication Vanne Boost actived
					
					
					Case "8" 'Mode Auto
						CallSub3(Setup_Power_connected,"BLE_return",Event_Read_Mode_BLE,"Auto")
					Case "9" 'Mode Manuel
						CallSub3(Setup_Power_connected,"BLE_return",Event_Read_Mode_BLE,"Manuel")
					Case "A" 'Holiday Mode
						CallSub3(Setup_Power_connected,"BLE_return",Event_Read_Mode_BLE,"Vacance")
					Case "C" 'Boost Mode return mode Auto
						CallSub3(Setup_Power_connected,"BLE_return",Event_Read_Boost_BLE,"On")
					Case "D" 'Boost Mode return mode Manuel
						CallSub3(Setup_Power_connected,"BLE_return",Event_Read_Boost_BLE,"On")
					Case "E" 'Boost Mode return mode Holiday
						CallSub3(Setup_Power_connected,"BLE_return",Event_Read_Boost_BLE,"On")
							
				End Select
				
				'Relevé Réglage electrovanne
				
				Dim byte1(1) As Byte
				byte1(0)=value(3)
				Dim temp2 As String =byte1(0)
				Dim VanneSet As String= temp2 & "%"
				CallSub3(Setup_Power_connected,"BLE_return",Event_Read_Statut_Vanne,VanneSet)
				
									
				 'Relevé Température programmé
				Dim byte1(1) As Byte
				byte1(0)=value(5)
				Dim temp1 As String =byte1(0)
				Log("Temp :" & (temp1/2) & "°C")
				Dim tempSet As String=(temp1/2) & "°C"
				CallSub3(Setup_Power_connected,"BLE_return",Event_Read_Temp_BLE,tempSet)
				'End Select
				
			End If
			
			
'			If value.Length<>0 Then
'				If ServiceId=Service_Temp Then
'					'Niv_Batterie=value(0) & "%"
'					If value(0)=03 Then 'Temp Manuel
'					Dim byte1(1) As Byte
'						byte1(0)=value(1)
'						Dim temp1 As String =byte1(0)
'						Log("Temp :" & (temp1/2) & "°C")
'						Dim tempSet As String=(temp1/2) & "°C"
'						CallSub3(Setup_Power_connected,"BLE_return",Event_Read_Temp_BLE,tempSet)
'						'manager.Disconnect
'					End If
'					'Log("Level Battery : " & value(0) & "%")
'				
'				Else
'					'Log(BytesToString(value, 0, value.Length, "UTF8"))
'					'Dim data_sensor() As String= Regex.Split(" ", BytesToString(value, 0, value.Length, "UTF8"))
'					'Temp_sensor=data_sensor(0)
'					'Hydro_sensor=data_sensor(1)
'				End If
'			End If
			
		Next
	Catch
		Log(LastException)
	End Try
End Sub

Sub Service_Destroy

End Sub
