﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=10.7
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
Public testmap As Map
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private ImageViewxiaomi1 As B4XView
	Private ImageViewXiaomi2 As B4XView
	Private Lblcheck1 As B4XView
	Private Lblcheck2 As B4XView
	Private Pnlsensor1 As B4XView
	Private LblRetourHHDone As B4XView
	
	Private LblNext As B4XView
	Private LblBack As B4XView
	Private Pnlsensor2 As B4XView
	Private StepInstall As Int=0
	Private LblstepText As B4XView
	Private LblMessagePile As B4XView
	Private BtnStartPair As B4XView
	Private TypeSensor,TypePower,TypeBeacon As Int
		
	TypeSensor=1
	TypePower=2
	TypeBeacon=3
	
	Private ActionAdd, ActionModif, ActionSupp As Int
	
	ActionAdd=1
	ActionModif=2
	ActionSupp=3
	Private NameOfDevice As String=""
	Private RefSensor As String ="MJ_HT_V1"
	Private RefSensormini As String ="LYWSD03MMC"
	Private RefThermo As String ="CC-RT-BLE"
	
	Private EditTxt_Lieu As B4XView
	Private AnotherProgressBar1 As AnotherProgressBar
	Private EdittextLocalisation As B4XView
	
	Dim Download_ReturnHHDOne, UploadInstallDevice, Download_Conf_HH,Upload_Conf_HH,Upload_Conf_HDDONE As Int
	
	Download_Conf_HH=4
	Upload_Conf_HH=6
	Download_ReturnHHDOne=12
	UploadInstallDevice=13
	Upload_Conf_HDDONE=14
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	Activity.LoadLayout("InstallationDevice")
	
	If Main.AccoutMap.get("StartNewInstallation")=False Then 
		EdittextLocalisation.Text= Main.Localisation_Home
		EdittextLocalisation.Enabled=False
	Else
		EdittextLocalisation.Enabled=True
	End If
	
End Sub


'*************** Select Sensor ***********************
Private Sub ImageViewXiaomi2_Click
	Lblcheck1.Visible=False
	Lblcheck2.Visible=True
	NameOfDevice=RefSensormini
End Sub

Private Sub ImageViewxiaomi1_Click
	Lblcheck1.Visible=True
	Lblcheck2.Visible=False
	NameOfDevice=RefSensor
End Sub

Sub Activity_Resume
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	Main.Modeinstall=True
		
End Sub

'*********Generation JsonFile Installation*******************

Sub TypeInstallation(TypeDevice As Int,TypeAction As Int,Localisation As String,NameDevice As String)
	
	Dim jg As JSONGenerator
						
	'Dim MapParameter As Map
	'MapParameter.Initialize

	'MapParameter.Put("CreateAccount",False)
	Main.AccoutMap.Put("CreateWifiConnect",False)
	Main.AccoutMap.Put("ConfigurationStep",Main.StepConf)
	
	Select Case TypeDevice
		Case TypeSensor
			'MapParameter.Put("ProgDeviceType","")
			Main.AccoutMap.Put("ProgSensorType",NameDevice)
			'MapParameter.Put("ProgBeaconType","")
			
			Select Case TypeAction
				Case ActionAdd
					Main.AccoutMap.Put("AddSensor",True)
					'MapParameter.Put("ModifSensor","False")
					'MapParameter.Put("DeleteSensor","False")
				Case ActionModif
					'MapParameter.Put("AddSensor","False")
					Main.AccoutMap.Put("ModifSensor",True)
					'MapParameter.Put("DeleteSensor","False")
				Case ActionSupp
					'MapParameter.Put("AddSensor","False")
					'MapParameter.Put("ModifSensor","False")
					Main.AccoutMap.Put("DeleteSensor",True)
			End Select
		Case TypePower
			Main.AccoutMap.Put("ProgDeviceType",NameDevice)
			'MapParameter.Put("ProgSensorType","")
			'MapParameter.Put("ProgBeaconType","")
			
			Select Case TypeAction
				Case ActionAdd
					Main.AccoutMap.Put("AddDevice",True)
					'MapParameter.Put("ModifDevice","False")
					'MapParameter.Put("DeleteDevice","False")
				Case ActionModif
					'MapParameter.Put("AddDevice","False")
					Main.AccoutMap.Put("ModifDevice",True)
					'MapParameter.Put("DeleteDevice","False")
				Case ActionSupp
					'MapParameter.Put("AddDevice","False")
					'MapParameter.Put("ModifDevice","False")
					Main.AccoutMap.Put("DeleteDevice",True)
			End Select
		Case TypeBeacon	
			'MapParameter.Put("ProgDeviceType","")
			'MapParameter.Put("ProgSensorType","")
			Main.AccoutMap.Put("ProgBeaconType",NameDevice)
			
			Select Case TypeAction
				Case ActionAdd
					Main.AccoutMap.Put("AddBeacon",True)
					'MapParameter.Put("ModifBeacon","False")
					'MapParameter.Put("DeleteBeacon","False")
				Case ActionModif
					'MapParameter.Put("AddBeacon","False")
					Main.AccoutMap.Put("ModifBeacon",True)
					'MapParameter.Put("DeleteBeacon","False")
				Case ActionSupp
					'MapParameter.Put("AddBeacon","False")
					'MapParameter.Put("ModifBeacon","False")
					Main.AccoutMap.Put("DeleteBeacon",True)
			End Select
	End Select
	
		
	Main.AccoutMap.Put("Location",Localisation)
				
											
	jg.Initialize(Main.AccoutMap)
	
				
	' Upload du fichier de configuration HHDOne sur le Cloud
	wait for (Param.Write_Json_File(Main.HHDOneAccountFile ,jg.ToPrettyString(4))) complete (Result3 As Boolean)
	
	Main.type_transfert=UploadInstallDevice
	If IsPaused(Transfert_Server)=True Then
		StartService(Transfert_Server)
	End If
	
End Sub

'**************Step Installation*****************

Private Sub LblNext_Click
	StepInstall=StepInstall+1
	
	Select Case StepInstall
		Case 1
			If (Lblcheck1.Visible=True Or Lblcheck2.Visible=True) And EdittextLocalisation.Text<>"" Then
				
				'**********Envoi du fichier de localisation**********
				wait for (SendLocalisationFile) complete (result3 As Boolean)
				
				'wait for (SendHDDONEMAC) complete (result4 As Boolean)
				
				If result3=True Then 'And result4=True Then
					'Pnlsensor1.visible=False
					Pnlsensor2.visible=True
					LblstepText.Text= "Etape 2"
					LblBack.Visible=True
				
					If Lblcheck1.Visible=True Then
						LblMessagePile.Text="Insérez la pile dans votre sonde de température."
					Else if Lblcheck2.Visible=True Then
						LblMessagePile.Text="Tirez la languette pour activer votre sonde de température."
					End If
				End If
				
				
			Else
				StepInstall=StepInstall-1
				If EdittextLocalisation.Text<>"" Then 
					ToastMessageShow("Vous devez selectionner un modèle de sonde", True)
				Else
					ToastMessageShow("Vous devez donner un nom à votre résidence", True)
				End If
				
			End If
			
		Case 2
			
		Case 3
		
	End Select
	
End Sub


Private Sub LblBack_Click
	StepInstall=StepInstall-1
	
	Select Case StepInstall
		Case 1
			
			Pnlsensor1.visible=True
			Pnlsensor2.visible=False
			LblstepText.Text= "Etape 1"
			LblBack.Visible=False
			LblRetourHHDone.Visible=False
		Case 2
			
		Case 3
		
	End Select
	
	Pnlsensor2.visible=False
	Pnlsensor1.visible=True
End Sub

' ****************************Create Localization File and HDDONEList File*********************

Sub SendLocalisationFile As ResumableSub
	
	Dim jg As JSONGenerator
	Dim MapParameter As Map
		
	MapParameter.Initialize
	MapParameter.Put("NberOfHome",1)
	MapParameter.Put("Home" & 1,Main.Macadd & "/" & EdittextLocalisation.text)
	Main.NewLocalisation=EdittextLocalisation.text
	
	jg.Initialize(MapParameter)
					
	' Upload du fichier de configuration HHDOne sur le Cloud
	wait for (Param.Write_Json_File(Main.FileLocalisation ,jg.ToPrettyString(4))) complete (Result3 As Boolean)
	
	Main.type_transfert=Upload_Conf_HH
	If IsPaused(Transfert_Server)=True Then
		StartService(Transfert_Server)
	End If
		
	Return Result3
	
End Sub

' ****************************Create HDDONE MAC File and HDDONEList File*********************

'Sub SendHDDONEMAC As ResumableSub
'	
'	Dim jg As JSONGenerator
'	Dim MapParameter As Map
'	Dim i As Int =1
'	
'	MapParameter.Initialize
'	MapParameter.Put("HDDONE " & i,Main.Macadd)
'		
'	jg.Initialize(MapParameter)
'					
'	' Upload du fichier de configuration HHDOne sur le Cloud
'	wait for (Param.Write_Json_File(Main.FileHDDONE ,jg.ToPrettyString(4))) complete (Result4 As Boolean)
'	
'	Main.type_transfert=Upload_Conf_HDDONE
'	If IsPaused(Transfert_Server)=True Then
'		StartService(Transfert_Server)
'	End If
'	
'	Return  Result4
'End Sub
'***************Send Installation**************

Private Sub BtnStartPair_Click
	
	If EditTxt_Lieu.Text="" Then
		ToastMessageShow("Précisez la localisation",True)
	Else
		AnotherProgressBar1.Visible=True
		TypeInstallation(TypeSensor,ActionAdd,EditTxt_Lieu.Text,NameOfDevice)
	End If
	
	
End Sub

Sub ReturnHHDOne(FileExited As Boolean,Status As Boolean)
	LblRetourHHDone.Visible=True
	If Status=True Then
		AnotherProgressBar1.Visible=False
		LblRetourHHDone.SetColorAndBorder(0xFF5B6882,4dip,0xFFFF0800,10dip)
		LblRetourHHDone.Text="La HHDOne ne répond pas." & CRLF & "Recommencez l'appairage"
	Else if FileExited=False Then
		LblRetourHHDone.SetColorAndBorder(0xFF5B6882,4dip,0xFFF6FF00,10dip)
		LblRetourHHDone.Text="Paramétrage en cours..."
		
	End If
	
End Sub

Sub ReturnHHDOne1(Status As Boolean)
	
	AnotherProgressBar1.Visible=False
	If Status=True Then
		
		If Main.ResponseHHDOne="InstallationSensorOK" Then
			LblRetourHHDone.SetColorAndBorder(0xFF5B6882,4dip,0xFF66D53A,10dip)
			LblRetourHHDone.Text="La sonde est maintenant associée à la HHDOne." & CRLF & "Positionnez là dans la pièce définie"
			
		Else If Main.ResponseHHDOne="InstallationSensorKO" Then
			LblRetourHHDone.Text="L'apparaige de la sonde a échoué." & CRLF & "Relancez l'appairage"
		End If
		
	Else
		LblRetourHHDone.Text="La HHDOne ne répond pas." & CRLF & "Assurez-vous que la HHDOne est alimentée"
	End If
	
End Sub